// MyTime.cpp : implementation file
//
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "MyStream.h"
#include "MyTime.h"


int CMyTime::setn(char* ni){
  strcpy(name, ni); 
  return 1;
}
CMyTime::CMyTime(int mi, char* ni="name"){
  min = mi;
  name = new char[BUFLEN];
  setn(ni);
  myofs << "CMyTime: in parametric constructor ";
  myofs << *this << endl; 
}
CMyTime::CMyTime(){
  min = 33;
  name = new char[BUFLEN];
  setn("");
  myofs << "CMyTime: in default constructor "; 
  myofs << *this << endl; 
}
CMyTime::CMyTime(const CMyTime& cmt){
  min = cmt.min;
  name = new char[BUFLEN];
  setn(cmt.name);
  myofs << " CMyTime: in copy constructor ";
  myofs << *this << endl; 
} 
CMyTime::~CMyTime()
{
  myofs << "CMyTime: in destructor ";
  myofs << *this << endl; 
  delete name;
  name=NULL;
}
CMyTime& CMyTime::operator=(CMyTime& cmt)
{
  if(this != &cmt)
  { 
	min = cmt.min;
    setn(cmt.name);
  }
	return *this;
}
bool CMyTime::operator<(const CMyTime& cmt)
{
  if(min<cmt.min) return true;
  return false;
}
bool CMyTime::operator>(const CMyTime& cmt){
  if(min>cmt.min) return true;
  return false;
}
bool CMyTime::operator==(const CMyTime& cmt){
  if(min == cmt.min) return true;
  return false;
}
CMyTime::operator int()const
{
  return min;
}
bool CMyTime::operator!=(const CMyTime& cmt)
{
  if(min != cmt.min) return true;
  return false;
}
CMyTime& CMyTime::operator!()
{
  char buf[BUFLEN]; 
  int k, m;
  strcpy(buf, name);
  k = strlen(buf);
  for(m=0; m<k; m++) 
    name[m] = buf[k-m-1];
  min=60-min; 
  return *this;
}
CMyTime operator+(CMyTime& cmt1, CMyTime& cmt2)
{
  CMyTime cmt; 
  char buf1[BUFLEN]; char buf2[BUFLEN];
  cmt1.getn(buf1);
  strcat(buf1, " + ");
  cmt2.getn(buf2);
  strcat(buf1, buf2);
  cmt.setn(buf2);
  cmt.setm(cmt1.min + cmt2.min);
  return cmt;
}
CMyTime operator+(int mi, CMyTime& cmt)
{
  CMyTime tmp; 
  tmp.setn(cmt.name);
  tmp.setm(mi + cmt.min);
  return tmp;
}
CMyTime operator-(CMyTime& cmt, int mi)
{
  CMyTime tmp; 
  tmp.setn(cmt.name);
  tmp.setm(cmt.min - mi);
  return tmp;
}
CMyTime operator+(CMyTime& cmt, int mi)
{
  CMyTime tmp = mi + cmt;
  return tmp;
}
int CMyTime::MyPrint(char* title, char* buf)
{
  char buf1[BUFLEN];
  sprintf(buf1, " %3d min ", min);
  strcpy(buf, title);
  strcat(buf, buf1);
  strcat(buf, " <");
  strcat(buf, name);
  strcat(buf, " ");
  return 1;
}
ofstream& operator<<(ofstream& ofs, CMyTime& cmt)
{
  myofs << "(" << setw(3) << cmt.min << ") ";
  myofs << " " << setw(10) << cmt.name;
  return ofs;
} 
ifstream& operator>>(ifstream& ifs, CMyTime& cmt){
  ifs >> cmt.min;
  char buf[BUFLEN];
  myifs >> buf; 
  strcpy(cmt.name, buf); 
  myifs.getline(buf, 200);
  return ifs;
} 
int swap(CMyTime* ptim1, CMyTime* ptim2)
{
  CMyTime* ptim = new CMyTime;
  *ptim = *ptim1;
  *ptim1 = *ptim2;
  *ptim2 = *ptim;
  delete ptim;
  return 1;
}
int CMyTime::swap(CMyTime* ptim2)
{
  CMyTime* ptim = new CMyTime;
  *ptim = *this;
  *this = *ptim2;
  *ptim2 = *this;
  delete ptim;
  return 1;
}

int decr(int ncur, int N){ncur--; if(ncur<0) ncur=0; return ncur;} 
int incr(int ncur, int N){ncur++; if(ncur>=N) ncur=N-1; return ncur;} 

int sort(CMyTime *tims, int N)
{
  int m, n, k;
  CMyTime* pcmt = new CMyTime;
  for(m=0; m<N-1; m++){
    k = m;
    for(n=m+1; n<N; n++){
      if(tims[k]>tims[n]) k=n;
    }
    if(m<k){
      *pcmt = tims[m];
      tims[m] = tims[k];
      tims[k] = *pcmt;
    }
  }
  delete pcmt;
  return 1; 
}

